{$S-,D-
        CRT Extention Unit
        by Sergey Kasandrov, June 94.
        Public Domain
}

Unit TCRT;

Interface

Uses CRT;

const
            Off = False;      On = True;

{ Color definitions, thanks to W.G. Madison and Associates, Ltd.}

   Blink = $80;
   Black  = $0;   Blue      = $1;   Green   = $2;   Cyan   = $3;
   Red    = $4;   Magenta   = $5;   Brown   = $6;   LtGray = $7;
   DkGray = $8;   LtBlue    = $9;   LtGreen = $A;   LtCyan = $B;
   LtRed  = $C;   LtMagenta = $D;   Yellow  = $E;   White  = $F;

   BlackOnBlack       = $00;         DkGrayOnBlack        = $08;
   BlueOnBlack        = $01;         LtBlueOnBlack        = $09;
   GreenOnBlack       = $02;         LtGreenOnBlack       = $0A;
   CyanOnBlack        = $03;         LtCyanOnBlack        = $0B;
   RedOnBlack         = $04;         LtRedOnBlack         = $0C;
   MagentaOnBlack     = $05;         LtMagentaOnBlack     = $0D;
   BrownOnBlack       = $06;         YellowOnBlack        = $0E;
   LtGrayOnBlack      = $07;         WhiteOnBlack         = $0F;

   BlackOnBlue        = $10;         DkGrayOnBlue         = $18;
   BlueOnBlue         = $11;         LtBlueOnBlue         = $19;
   GreenOnBlue        = $12;         LtGreenOnBlue        = $1A;
   CyanOnBlue         = $13;         LtCyanOnBlue         = $1B;
   RedOnBlue          = $14;         LtRedOnBlue          = $1C;
   MagentaOnBlue      = $15;         LtMagentaOnBlue      = $1D;
   BrownOnBlue        = $16;         YellowOnBlue         = $1E;
   LtGrayOnBlue       = $17;         WhiteOnBlue          = $1F;

   BlackOnGreen       = $20;         DkGrayOnGreen        = $28;
   BlueOnGreen        = $21;         LtBlueOnGreen        = $29;
   GreenOnGreen       = $22;         LtGreenOnGreen       = $2A;
   CyanOnGreen        = $23;         LtCyanOnGreen        = $2B;
   RedOnGreen         = $24;         LtRedOnGreen         = $2C;
   MagentaOnGreen     = $25;         LtMagentaOnGreen     = $2D;
   BrownOnGreen       = $26;         YellowOnGreen        = $2E;
   LtGrayOnGreen      = $27;         WhiteOnGreen         = $2F;

   BlackOnCyan        = $30;         DkGrayOnCyan         = $38;
   BlueOnCyan         = $31;         LtBlueOnCyan         = $39;
   GreenOnCyan        = $32;         LtGreenOnCyan        = $3A;
   CyanOnCyan         = $33;         LtCyanOnCyan         = $3B;
   RedOnCyan          = $34;         LtRedOnCyan          = $3C;  
   MagentaOnCyan      = $35;         LtMagentaOnCyan      = $3D;
   BrownOnCyan        = $36;         YellowOnCyan         = $3E;  
   LtGrayOnCyan       = $37;         WhiteOnCyan          = $3F;

   BlackOnRed         = $40;         DkGrayOnRed          = $48;
   BlueOnRed          = $41;         LtBlueOnRed          = $49;
   GreenOnRed         = $42;         LtGreenOnRed         = $4A;  
   CyanOnRed          = $43;         LtCyanOnRed          = $4B;
   RedOnRed           = $44;         LtRedOnRed           = $4C;
   MagentaOnRed       = $45;         LtMagentaOnRed       = $4D;
   BrownOnRed         = $46;         YellowOnRed          = $4E;
   LtGrayOnRed        = $47;         WhiteOnRed           = $4F;

   BlackOnMagenta     = $50;         DkGrayOnMagenta      = $58;
   BlueOnMagenta      = $51;         LtBlueOnMagenta      = $59;
   GreenOnMagenta     = $52;         LtGreenOnMagenta     = $5A; 
   CyanOnMagenta      = $53;         LtCyanOnMagenta      = $5B; 
   RedOnMagenta       = $54;         LtRedOnMagenta       = $5C;
   MagentaOnMagenta   = $55;         LtMagentaOnMagenta   = $5D;
   BrownOnMagenta     = $56;         YellowOnMagenta      = $5E;
   LtGrayOnMagenta    = $57;         WhiteOnMagenta       = $5F;

   BlackOnBrown       = $60;         DkGrayOnBrown        = $68;
   BlueOnBrown        = $61;         LtBlueOnBrown        = $69;
   GreenOnBrown       = $62;         LtGreenOnBrown       = $6A; 
   CyanOnBrown        = $63;         LtCyanOnBrown        = $6B; 
   RedOnBrown         = $64;         LtRedOnBrown         = $6C;
   MagentaOnBrown     = $65;         LtMagentaOnBrown     = $6D;
   BrownOnBrown       = $66;         YellowOnBrown        = $6E;
   LtGrayOnBrown      = $67;         WhiteOnBrown         = $6F;

   BlackOnLtGray      = $70;         DkGrayOnLtGray       = $78;
   BlueOnLtGray       = $71;         LtBlueOnLtGray       = $79;
   GreenOnLtGray      = $72;         LtGreenOnLtGray      = $7A;
   CyanOnLtGray       = $73;         LtCyanOnLtGray       = $7B;
   RedOnLtGray        = $74;         LtRedOnLtGray        = $7C;
   MagentaOnLtGray    = $75;         LtMagentaOnLtGray    = $7D;
   BrownOnLtGray      = $76;         YellowOnLtGray       = $7E;
   LtGrayOnLtGray     = $77;         WhiteOnLtGray        = $7F;

   BlackOnDkGray      = $80;         DkGrayOnDkGray       = $88;
   BlueOnDkGray       = $81;         LtBlueOnDkGray       = $89;
   GreenOnDkGray      = $82;         LtGreenOnDkGray      = $8A;
   CyanOnDkGray       = $83;         LtCyanOnDkGray       = $8B;
   RedOnDkGray        = $84;         LtRedOnDkGray        = $8C;
   MagentaOnDkGray    = $85;         LtMagentaOnDkGray    = $8D;
   BrownOnDkGray      = $86;         YellowOnDkGray       = $8E;
   LtGrayOnDkGray     = $87;         WhiteOnDkGray        = $8F;

   BlackOnLtBlue      = $90;         DkGrayOnLtBlue       = $98;
   BlueOnLtBlue       = $91;         LtBlueOnLtBlue       = $99;
   GreenOnLtBlue      = $92;         LtGreenOnLtBlue      = $9A;
   CyanOnLtBlue       = $93;         LtCyanOnLtBlue       = $9B;
   RedOnLtBlue        = $94;         LtRedOnLtBlue        = $9C;
   MagentaOnLtBlue    = $95;         LtMagentaOnLtBlue    = $9D;
   BrownOnLtBlue      = $96;         YellowOnLtBlue       = $9E;
   LtGrayOnLtBlue     = $97;         WhiteOnLtBlue        = $9F;

   BlackOnLtGreen     = $A0;         DkGrayOnLtGreen      = $A8;
   BlueOnLtGreen      = $A1;         LtBlueOnLtGreen      = $A9;
   GreenOnLtGreen     = $A2;         LtGreenOnLtGreen     = $AA;
   CyanOnLtGreen      = $A3;         LtCyanOnLtGreen      = $AB;
   RedOnLtGreen       = $A4;         LtRedOnLtGreen       = $AC;
   MagentaOnLtGreen   = $A5;         LtMagentaOnLtGreen   = $AD;
   BrownOnLtGreen     = $A6;         YellowOnLtGreen      = $AE;
   LtGrayOnLtGreen    = $A7;         WhiteOnLtGreen       = $AF;

   BlackOnLtCyan      = $B0;         DkGrayOnLtCyan       = $B8;
   BlueOnLtCyan       = $B1;         LtBlueOnLtCyan       = $B9;
   GreenOnLtCyan      = $B2;         LtGreenOnLtCyan      = $BA;
   CyanOnLtCyan       = $B3;         LtCyanOnLtCyan       = $BB;
   RedOnLtCyan        = $B4;         LtRedOnLtCyan        = $BC;
   MagentaOnLtCyan    = $B5;         LtMagentaOnLtCyan    = $BD;
   BrownOnLtCyan      = $B6;         YellowOnLtCyan       = $BE;  
   LtGrayOnLtCyan     = $B7;         WhiteOnLtCyan        = $BF;

   BlackOnLtRed       = $C0;         DkGrayOnLtRed        = $C8;
   BlueOnLtRed        = $C1;         LtBlueOnLtRed        = $C9;
   GreenOnLtRed       = $C2;         LtGreenOnLtRed       = $CA;  
   CyanOnLtRed        = $C3;         LtCyanOnLtRed        = $CB;
   RedOnLtRed         = $C4;         LtRedOnLtRed         = $CC;
   MagentaOnLtRed     = $C5;         LtMagentaOnLtRed     = $CD;
   BrownOnLtRed       = $C6;         YellowOnLtRed        = $CE;
   LtGrayOnLtRed      = $C7;         WhiteOnLtRed         = $CF;

   BlackOnLtMagenta   = $D0;         DkGrayOnLtMagenta    = $D8;
   BlueOnLtMagenta    = $D1;         LtBlueOnLtMagenta    = $D9;
   GreenOnLtMagenta   = $D2;         LtGreenOnLtMagenta   = $DA; 
   CyanOnLtMagenta    = $D3;         LtCyanOnLtMagenta    = $DB; 
   RedOnLtMagenta     = $D4;         LtRedOnLtMagenta     = $DC;
   MagentaOnLtMagenta = $D5;         LtMagentaOnLtMagenta = $DD;
   BrownOnLtMagenta   = $D6;         YellowOnLtMagenta    = $DE;
   LtGrayOnLtMagenta  = $D7;         WhiteOnLtMagenta     = $DF;

   BlackOnYellow      = $E0;         DkGrayOnYellow       = $E8;
   BlueOnYellow       = $E1;         LtBlueOnYellow       = $E9;
   GreenOnYellow      = $E2;         LtGreenOnYellow      = $EA; 
   CyanOnYellow       = $E3;         LtCyanOnYellow       = $EB; 
   RedOnYellow        = $E4;         LtRedOnYellow        = $EC;
   MagentaOnYellow    = $E5;         LtMagentaOnYellow    = $ED;
   BrownOnYellow      = $E6;         YellowOnYellow       = $EE;
   LtGrayOnYellow     = $E7;         WhiteOnYellow        = $EF;

   BlackOnWhite       = $F0;         DkGrayOnWhite        = $F8;
   BlueOnWhite        = $F1;         LtBlueOnWhite        = $F9;
   GreenOnWhite       = $F2;         LtGreenOnWhite       = $FA; 
   CyanOnWhite        = $F3;         LtCyanOnWhite        = $FB; 
   RedOnWhite         = $F4;         LtRedOnWhite         = $FC;
   MagentaOnWhite     = $F5;         LtMagentaOnWhite     = $FD;
   BrownOnWhite       = $F6;         YellowOnWhite        = $FE;
   LtGrayOnWhite      = $F7;         WhiteOnWhite         = $FF;

                                { Special key flags in KBFlags }
        
        InsFlag    = $80;            Alt    = $08;
        CapsLock   = $40;            Ctrl   = $04;
        NumLock    = $20;            LShift = $02;
        ScrollLock = $10;            RShift = $01;

                              { Values returned by ReadKeyWord }

        F1    = $3B00;               ArUp      = $4800;
        F2    = $3C00;               ArDn      = $5000;
        F3    = $3D00;               ArLt      = $4B00;
        F4    = $3E00;               ArRt      = $4D00;
        F5    = $3F00;               Ins       = $5200;
        F6    = $4000;               Del       = $5300;
        F7    = $4100;               Home      = $4700;
        F8    = $4200;               EndKey    = $4F00;
        F9    = $4300;               PgUp      = $4900;
        F10   = $4400;               PgDn      = $5100;
        Esc   = $011B;               Enter     = $1C0D;
        Tab   = $0F09;               ShiftTab  = $0F00;
        Space = $3920;               BackSpace = $0E08;

        WhitePlus  = $0D2B;          GrayPlus  = $4E2B;
        WhiteMinus = $0C2D;          GrayMinus = $4A2D;
        WhiteStar  = $092A;          GrayStar  = $372A;

   ShiftF1  = $5400;    CtrlF1  = $5E00;    AltF1  = $6800;
   ShiftF2  = $5500;    CtrlF2  = $5F00;    AltF2  = $6900;
   ShiftF3  = $5600;    CtrlF3  = $6000;    AltF3  = $6A00;
   ShiftF4  = $5700;    CtrlF4  = $6100;    AltF4  = $6B00;
   ShiftF5  = $5800;    CtrlF5  = $6200;    AltF5  = $6C00;
   ShiftF6  = $5900;    CtrlF6  = $6300;    AltF6  = $6D00;
   ShiftF7  = $5A00;    CtrlF7  = $6400;    AltF7  = $6E00;
   ShiftF8  = $5B00;    CtrlF8  = $6500;    AltF8  = $6F00;
   ShiftF9  = $5C00;    CtrlF9  = $6600;    AltF9  = $7000;
   ShiftF10 = $5D00;    CtrlF10 = $6700;    AltF10 = $7100;


var                                 { Keyboard status byte }
   KBFlags: Byte absolute $40:$17;

var                                   { Used by GetKeyWord }
   KeyWord: Word;

{
                        KEYBOARD  SERVICES
}

{     頥   }
function  ReadKeyWord: Word;

{ 頥  ⮩  ࠭   , 0 ᫨   }
function  NextKeyWord: Word;

{ 頥   }
procedure WashBuffer;

{ KeyWord:= ReadKeyWord }
procedure GetKeyWord;

{ True, ᫨ ० ⠢ }
function  InsMode: Boolean;

{ True, ᫨   Shift }
function  ShiftPressed: Boolean;

{ True, ᫨   Alt }
function  AltPressed: Boolean;

{
                        SCREEN  SERVICES
}

{ ४祭 ० 栭/16 梥⮢ 䮭 }
procedure SetBlink( Cond: Boolean);

{ ᢥ⪠ १ ப }
procedure FillBar( X, Y, Len, Attr: Byte);

{ ᢥ⪠ אַ㣮쭨 }
procedure FillBox( X1, Y1, X2, Y2, Attr: Byte);

{ ᪠  }
procedure FillWin( Ch: Char; Attr: Byte);

{ 뢮  ᯫ   梥 䮭 }
procedure WriteStr( X, Y: Byte; S: String; Attr: Byte);
procedure WriteChar( X, Y, Count: Byte; Ch: Char; Attr: Byte);
procedure WriteLine( X, Y: Byte; Count: Word; var Buf; Attr: Byte);

{ 뢮  ᯫ   梥 䮭 }
procedure WrStr( X, Y: Byte; S: String);
procedure WrChar( X, Y, Count: Byte; Ch: Char);
procedure WrLine( X, Y: Byte; Count: Word; var Buf);

{ ⠭ ࠧ஢  }
procedure SetCursorLines( ScanLines: Word);
procedure NormalCursor;
procedure FatCursor;
procedure BlockCursor;
procedure HiddenCursor;
procedure CheckCursor;

{
            LOW-LEVEL ROUTINES FOR WINDOW MANAGER
}

{ প ६ ࠭ 뢮 }
procedure SaveWin;
procedure RestoreWin;

{ 頥 ࠧ    }
function  WinSize: Word;

{ 頥 ࠧ ⥭    }
function  ShadeSize: Word;

{ ⥭  }
procedure ReadWin( var Buf);
procedure ReadShade( var Buf);

{    }
procedure WriteWin( var Buf);
procedure WriteShade( var Buf);

Implementation

var                         { Used by SaveWin and RestoreWin }
   SaveWindMin,
   SaveWindMax: Word;

{$L VIDEO}      procedure Win2Video; external;
                procedure Scr2Video; external;
{$L KEYWORD  }  function  ReadKeyWord; external;
{$L NEXTKEY  }  function  NextKeyWord; external;
{$L WASHBUF  }  procedure WashBuffer; external;
{$L SETBLINK }  procedure SetBlink; external;
{$L FILLBAR  }  procedure FillBar; external;
{$L FILLBOX  }  procedure FillBox; external;
{$L FILLWIN  }  procedure FillWin; external;
{$L WRITESTR }  procedure WriteStr; external;
{$L WRITCHAR }  procedure WriteChar; external;
{$L WRITLINE }  procedure WriteLine; external;
{$L WRSTR    }  procedure WrStr; external;
{$L WRCHAR   }  procedure WrChar; external;
{$L WRLINE   }  procedure WrLine; external;
{$L WINSIZE  }  function  WinSize; external;
{$L SHADESIZ }  function  ShadeSize; external;
{$L READWIN  }  procedure ReadWin; external;
{$L REASHADE }  procedure ReadShade; external;
{$L WRITEWIN }  procedure WriteWin; external;
{$L WRISHADE }  procedure WriteShade; external;
{$L SETCURS  }  procedure SetCursorLines; external;

procedure GetKeyWord;
   begin
      KeyWord:= ReadKeyWord;
   end;

procedure SaveWin;
   begin
      SaveWindMin:= WindMin;
      SaveWindMax:= WindMax;
      WindMin:= 0;
      WindMax:= 24*256+79;
   end;

procedure RestoreWin;
   begin
      WindMin:= SaveWindMin;
      WindMax:= SaveWindMax;
   end;

procedure NormalCursor;
   begin
      SetCursorLines($0607);
   end;

procedure FatCursor;
   begin
      SetCursorLines($0407);
   end;

procedure BlockCursor;
   begin
      SetCursorLines($0007);
   end;

procedure HiddenCursor;
   begin
      SetCursorLines($2000);
   end;

procedure CheckCursor;
   begin
      if InsMode then NormalCursor
      else BlockCursor;
   end;

function InsMode;
   begin
      InsMode:= (KBFlags and InsFlag)<>0;
   end;

function ShiftPressed;
   begin
      ShiftPressed:= (KBFlags and (RShift+LShift))<>0;
   end;

function AltPressed;
   begin
      AltPressed:= (KBFlags and Alt)<>0;
   end;

end.
